Subject: Re: [hrpc] Language analysis of RFCs

From: Niels ten Oever <[email-masked]>
Date: Sun, 05 Jul 2015 01:59:38 +0700

Hi all,

I hope this email finds you well. I am writing as a follow-up to the
earlier discussion about the analysis of specific words used in RFCs.
Joe got me in contact with Nicolas Noty, who just joined the list
(welcome Nicolas!), and it turned out that for a very interesting and
relevant research paper he wrote [0], he developed a tool [1] with which
we should be able to do the analysis.

I added the terms to the search.py file and ran the scripts and we're
already getting somewhere, please find some graphs attached.

Nicolas and I have been thinking about what could be some next steps,
but your input would also be very valuable, and of course also your
contributions in terms of code and/or pull requests.

Some of the next steps we thought off:
1. Stemming of graphs
2. Improve graphics (anyone good with d3 Java Script?)

Is there anyone on the list interested in working on this? And do you
think this might be relevant to the broader IETF community so we post
something to [email-masked] to see if there is interest in further
developing this?

Looking forward to hear from you.

Best,

Niels

PS Nicolas, please let correct me if I missed something.

[0] https://npdoty.name/privacy-reviews/iwpe/
[1] https://github.com/npdoty/rfc-analysis/

Niels ten Oever
Head of Digital

Article 19
www.article19.org

PGP fingerprint    8D9F C567 BEE4 A431 56C4
                   678B 08B5 A0F2 636D 68E9

On 06/21/2015 11:39 PM, Niels ten Oever wrote:
> Hi Stephen,
> 
> This would also be very useful while working on the glossary (for
> which I am looking for different ways technical terms are defined in
> the IETF).
> 
> Do you think it might be useful to pose this questions to IETF discuss
> ([email-masked]) ?
> 
> Best,
> 
> Niels
> 
> 
> Niels ten Oever
> Head of Digital
> 
> Article 19
> www.article19.org
> 
> PGP fingerprint    8D9F C567 BEE4 A431 56C4
>                    678B 08B5 A0F2 636D 68E9
> 
> On 06/20/2015 01:26 PM, Stephen Farrell wrote:
> 
>> Not sure if there is or is not a way to usefully do it, but if you
>> could generalise to developing a tool that could accept any set of
>> input terms (e.g. AES, crypto, NAT) then you might find that is
>> sufficiently useful to attract other folks to help with getting the
>> data.
> 
>> S.
> 
>> On 20/06/15 15:55, Niels ten Oever wrote:
>>> Dear all,
>>>
>>> We had the idea of analyzing RFCs for certain terms which could
>>> help us identify more relevant RFCs for our work and analyze
>>> trends in the use of certain (combinations of) concepts.
>>> Unfortunately the person that volunteered to help us with that
>>> couldn't complete this work due to other commitments.
>>>
>>> We discussed this at the interim meeting and Corinne and dkg said
>>> they might know people that could help us with this, Joe also
>>> suggested someone. Underneath I'm sharing with you and updated
>>> version email I sent to the person that was going to help us with
>>> this.
>>>
>>> It would be great if you could let me know if you think this is 
>>> useful, whether something should be changed or added. And of
>>> course, feel free to send this email to anyone who could help up
>>> with this.
>>>
>>> Looking forward to discuss.
>>>
>>> Best,
>>>
>>> Niels
>>>
>>>
>>> Hi [**]
>>>
>>> I hope this e-mail finds you well. What I am looking for someone
>>> or a tool to analyze all Internet Standards (RFCs) for a number
>>> of terms.
>>>
>>> All RFCs can be found here:
>>> https://www.rfc-editor.org/getbulk.html
>>>
>>> The concepts I would like to scan for are (non-case sensitive):
>>>
>>> Interoperability, Distributed architecture, Distributed, End to
>>> end, Reliability, Resiliency, resilience, Permissionless
>>> innovation, Transparency, Data minimization, Federation, Graceful
>>> degradation, Connectivity, Innovation at the edges, Content
>>> agnostic, application agnostic, graceful failure, partial
>>> healing, delay tolerance, data minimization, data compression,
>>> connectivity, stateless, statefull, scalable, transparent,
>>> debugging. robust. end user, decentralized, privacy, rights,
>>> surveillance, Internationalization, openness
>>>
>>> What I would like to get out of this is the ability to:
>>>
>>> 1. see which of these words are used in which RFC, 2. a timeline
>>> per concept how often it is used (to see if terms are more
>>> popular during a certain time period, to analyze for trends), 3.
>>> and then the ability to overlay these different analysis to see
>>> if a combination of terms occurs more regularly in a certain time
>>> period (in the same RFC or different ones).
>>>
>>> I imagine this done in the following way:
>>>
>>> Line graphs per technical concept in which the X axis is time
>>> and the Y axis is the amount of RFCs the term is mentioned in, it
>>> would be nice one could hover over/click on the line and see in
>>> which RFCs the concept is mentioned.
>>>
>>> We're doing this in the framework of the Human Rights Protocols 
>>> Considerations research group in the IETF / IRTF to see if there
>>> is a relation between human rights and protocols, and ultimately,
>>> to see if we can draft human right considerations for future
>>> protocol development to safeguard the Internet as a space that
>>> enables human rights.
>>>
>>> Looking forward to discuss and see whether and how we could best 
>>> approach this.
>>>
>>> Best,
>>>
>>> Niels
>>>
>>> _______________________________________________ hrpc mailing
>>> list [email-masked] https://www.irtf.org/mailman/listinfo/hrpc
>>>
> 
>